valentin/interviews/urls.py
from django.urls import path
from . import views

app_name = "interviews"

urlpatterns = [
    path(
        "profile/", views.InterviewerProfileEditView.as_view(), name="profile"
    ),
    path("sessions/", views.SessionListView.as_view(), name="list"),
    path(
        "<uuid:session_id>/dispo-select/",
        views.InterviewerDispoSelect.as_view(),
        name="dispo-select",
    ),
    path(
        "<uuid:session_id>/slot-select/",
        views.ContestantSlotSelect.as_view(),
        name="slot-select",
    ),
    path(
        "<uuid:session_id>/recap/",
        views.InterviewRecapView.as_view(),
        name="contestant-recap",
    ),
    path(
        "<uuid:session_id>/my-itw/",
        views.ContestantInterviewPortal.as_view(),
        name="contestant-portal",
    ),
    path(
        "<uuid:session_id>/my-itws/",
        views.InterviewerSlotsList.as_view(),
        name="interviewer-interviews",
    ),
    path(
        "<uuid:session_id>/grading/<int:contestant_id>/",
        views.ContestantGrading.as_view(),
        name="contestant-grading",
    ),
]

valentin/semifinals/urls.py
from django.urls import path
from django.contrib.auth.views import LoginView, LogoutView
from . import views

app_name = "semifinals"

urlpatterns = [
    path("login/", LoginView.as_view(), name="login"),
    path("logout/", LogoutView.as_view(next_page="/"), name="logout"),
    path("sessions/", views.SessionList.as_view(), name="session-list"),
    path(
        "session/<uuid:pk>/",
        views.SessionDetail.as_view(),
        name="session-details",
    ),
    path(
        "session/<uuid:pk>/subject",
        views.DownloadSessionSubjectView.as_view(),
        name="download-subject",
    ),
    path(
        "overseer/",
        views.SessionOverseerList.as_view(),
        name="session-overseer-list",
    ),
    path(
        "overseer/<uuid:session_id>/",
        views.SessionOverseer.as_view(),
        name="session-overseer",
    ),
    path(
        "contestant/", views.HomeContestant.as_view(), name="contestant-home"
    ),
    path("organizer/", views.HomeOrganizer.as_view(), name="organizer-home"),
    path("", views.HomeView.as_view(), name="home"),
]

valentin/valentin/urls.py
from django.contrib import admin
from django.urls import path, include

admin.site.site_header = "Administration Demi-Finales Prologin"

urlpatterns = [
    path("admin/", admin.site.urls),
    path("written-exams/", include("written_exams.urls")),
    path("itw/", include("interviews.urls")),
    path("", include("semifinals.urls")),
    path("social/", include("social_django.urls", namespace="social")),
]

valentin/interviews/forms.py
from django import forms
from . import models


class InterviewerProfile(forms.ModelForm):
    class Meta:
        model = models.Interviewer
        fields = [
            "meet_link",
            "email_notifications",
        ]


class IntervierwerDispoSelection(forms.Form):
    def __init__(self, *args, **kwargs):
        slot_choices = kwargs.pop("slot_choices")
        super().__init__(*args, **kwargs)
        self.fields["slot_choices"] = forms.MultipleChoiceField(
            choices=slot_choices,
            required=False,
            widget=forms.CheckboxSelectMultiple(),
        )


class ContestantSlotSelection(forms.Form):
    def __init__(self, *args, **kwargs):
        slot_choices = kwargs.pop("slot_choices")
        super().__init__(*args, **kwargs)
        self.fields["slot_choice"] = forms.ChoiceField(
            choices=slot_choices, required=True, widget=forms.RadioSelect()
        )


class GradingForm(forms.ModelForm):
    class Meta:
        model = models.InterviewScore
        fields = ["grade", "comments"]

valentin/interviews/views.py
from django.views.generic import (
    UpdateView,
    ListView,
    FormView,
    DetailView,
    RedirectView,
)
from django.core.mail import send_mail
from itertools import groupby
from valentin.utils import EnsureStaffMixin
from django.utils import timezone
from django.contrib.auth import get_user_model
from django.contrib.auth.mixins import LoginRequiredMixin
from django.core.exceptions import ObjectDoesNotExist, MultipleObjectsReturned
from django.http import HttpResponseGone, HttpResponseNotFound, Http404
from django.urls import reverse_lazy
from django.core.exceptions import SuspiciousOperation, PermissionDenied
from django.db import transaction
from django.template import loader as template_loader
from . import forms, models, mixins


class InterviewerProfileEditView(EnsureStaffMixin, UpdateView):
    form_class = forms.InterviewerProfile
    model = models.Interviewer
    template_name = "interviews/profile-edit.html"
    success_url = reverse_lazy("interviews:profile")

    def get_object(self, queryset=None):
        try:
            if queryset is None:
                return self.model.objects.get(user=self.request.user)
            return queryset.get(id=self.request.user.id)
        except ObjectDoesNotExist:
            return self.model(user=self.request.user)


class SessionListView(LoginRequiredMixin, ListView):
    template_name = "interviews/sessions-list.html"

    def get_queryset(self, *args, **kwargs):
        return models.Session.get_my_sessions(self.request.user)


class InterviewerDispoSelect(
    mixins.SessionObjectMixin, mixins.EnsureInterviewerMixin, FormView
):
    template_name = "interviews/interviewer-dispos-select.html"
    form_class = forms.IntervierwerDispoSelection
    session_passes_test = (
        lambda _, session: session.in_phase_1 or session.in_phase_2
    )

    def get_success_url(self, *args, **kwargs):
        return reverse_lazy("interviews:dispo-select", args=[self.session.id])

    def get_initial(self):
        initial = super().get_initial()
        user_slots = models.SlotInstance.objects.filter(
            slot__session=self.session, interviewer=self.interviewer
        )
        initial["slot_choices"] = tuple(sloti.slot_id for sloti in user_slots)
        return initial

    def get_form_kwargs(self):
        form_kwargs = super().get_form_kwargs()
        self.slot_choices = tuple(
            slot
            for slot in models.Slot.objects.filter(
                session=self.session, date_start__gt=timezone.now()
            ).order_by("date_start")
        )
        form_kwargs["slot_choices"] = tuple(
            (slot.id, slot.local_display) for slot in self.slot_choices
        )
        return form_kwargs

    def get_context_data(self, *args, **kwargs):
        context = super().get_context_data(*args, **kwargs)
        # Because of a weird django thing we are obliged to evaluate :(
        context["grouped_slot_choices"] = tuple(
            (i, list(j))
            for i, j in groupby(
                self.slot_choices, lambda d: d.date_start.date()
            )
        )
        context["session"] = self.session
        context["interviewer"] = self.interviewer
        return context

    def form_valid(self, form=None):
        if form.has_changed():
            initial, old_choices = self.get_initial(), set()
            new_choices = set(
                int(c) for c in form.cleaned_data["slot_choices"]
            )
            if initial and (slot_choices := initial.get("slot_choices")):
                old_choices = set(int(c) for c in slot_choices)

            deleted, added = tuple(old_choices - new_choices), tuple(
                new_choices - old_choices
            )
            with transaction.atomic():
                if self.session.in_phase_1:
                    models.SlotInstance.objects.filter(
                        interviewer=self.interviewer, slot_id__in=deleted
                    ).delete()
                for slot_id in added:
                    models.SlotInstance.objects.create(
                        interviewer=self.interviewer, slot_id=slot_id
                    )
        return super().form_valid(form)


class ContestantSlotSelect(
    LoginRequiredMixin, mixins.SessionObjectMixin, FormView
):
    template_name = "interviews/contestant-slot-select.html"
    form_class = forms.ContestantSlotSelection
    success_url = reverse_lazy("interviews:list")

    def session_passes_test(self, session):
        if self.request.user.is_staff:
            raise SuspiciousOperation(
                "Staff is trying to sign up as contestant in phase2"
            )
        if not session.status == models.SessionStatuses.CONTESTANT_CHOICE:
            return False
        if models.SlotInstance.objects.filter(
            contestant=self.request.user, slot__session=session
        ).exists():
            return False
        self.available_slots = tuple(
            filter(
                lambda x: x.instances.filter(contestant__isnull=True).exists(),
                models.Slot.objects.filter(
                    session=self.session, date_start__gt=timezone.now()
                ).order_by("date_start"),
            )
        )
        return True

    def get_context_data(self, *args, **kwargs):
        context = super().get_context_data(*args, **kwargs)
        context["session"] = self.session
        context["grouped_slot_choices"] = tuple(
            (i, list(j))
            for i, j in groupby(
                self.available_slots, lambda d: d.date_start.date()
            )
        )

        return context

    def get_form_kwargs(self, *args, **kwargs):
        form_kwargs = super().get_form_kwargs(*args, **kwargs)
        form_kwargs["slot_choices"] = tuple(
            (slot.id, "") for slot in self.available_slots
        )
        return form_kwargs

    def form_valid(self, form=None):
        with transaction.atomic():
            try:
                sloti = (
                    models.SlotInstance.objects.select_for_update()
                    .filter(
                        slot=form.cleaned_data["slot_choice"],
                        contestant__isnull=True,
                    )
                    .first()
                )
                sloti.contestant = self.request.user
                sloti.save()
                if sloti.interviewer.email_notifications:
                    send_mail(
                        "[ER][ITW] Nouvel entretien avec %s"
                        % (sloti.contestant_full_name,),
                        (
                            f"""
Bonjour {sloti.interviewer},

Votre créneau du {sloti.slot.local_display} a été assigné au
candidat {sloti.contestant_full_name}.

Cordialement,

Pensez à l'environnement, imprimez cet email sur du papier recyclé
uniquement.

--
Département Entretiens
Service des Épreuves Régionales
Association Prologin
"""
                        ),
                        None,
                        [sloti.interviewer.user.email],
                        fail_silently=True,
                    )
                return super().form_valid(form)
            except ObjectDoesNotExist:
                return HttpResponseGone(
                    content_type="text/plain",
                    content="The requested slot is out of order",
                )


class InterviewRecapView(
    mixins.SessionObjectMixin, LoginRequiredMixin, DetailView
):
    template_name = "interviews/my-interview.html"

    def session_passes_test(self, session):
        if self.request.user.is_staff:
            return False
        if not (session.in_phase_2 or session.in_phase_3):
            return False
        return True

    def get_context_data(self, *args, **kwargs):
        context = super().get_context_data(*args, **kwargs)
        context["session"] = self.session
        return context

    def render_detailed_404(self):
        content = template_loader.render_to_string(
            "interviews/no-interview.html", {}, self.request
        )
        res = HttpResponseNotFound(content, "text/html")
        return res

    def get_object(self, *args, **kwargs):
        return self.sloti

    def get(self, request, *args, **kwargs):
        try:
            self.sloti = models.SlotInstance.objects.get(
                slot__session=self.session, contestant=request.user
            )
            return super().get(request, *args, **kwargs)
        except MultipleObjectsReturned:
            raise Exception(
                f"{request.user.first_name} {request.user.last_name} has multiple slot instance assignations."  # noqa
            )
        except ObjectDoesNotExist:
            if self.session.in_phase_2:
                raise Http404
            return self.render_detailed_404()


class ContestantInterviewPortal(
    mixins.SessionObjectMixin, LoginRequiredMixin, RedirectView
):
    def get_redirect_url(self, *args, **kwargs):
        if (
            models.SlotInstance.objects.filter(
                slot__session=self.session, contestant=self.request.user
            ).exists()
            or self.session.in_phase_3
        ):
            return reverse_lazy(
                "interviews:contestant-recap", args=[self.session.id]
            )
        return reverse_lazy("interviews:slot-select", args=[self.session.id])

    def session_passes_test(self, session):
        if self.request.user.is_staff:
            return False
        if session.in_phase_0 or session.in_phase_1:
            return False

        return True


class InterviewerSlotsList(
    mixins.SessionObjectMixin, mixins.EnsureInterviewerMixin, ListView
):
    template_name = "interviews/interviews-list.html"

    def get_notations(self, session):
        return models.InterviewScore.objects.filter(
            session=session
        ).values_list("contestant", flat=True)

    def get_context_data(self, *args, **kwargs):

valentin/interviews/templates/interviews/contestant-grading.html
{% extends 'semifinals/base.html' %}
{% load static %}

{% block base_extra_head %}
<title>Notation de {{ object.contestant_full_name }}</title>
<link rel="stylesheet" href="{% static 'interviews/itw.css' %}">
{% endblock %}

{% block content %}
<div class="container">
    <small class="return-button"><a href="{% url 'interviews:interviewer-interviews' session.id %}">&lt;&nbsp; Retour au dérouleur prévisionnel entretiens</a></small>
    <h1 class="trb">Évaluation de {{ object.contestant_full_name }}</h1>
    {% if form.is_valid %}
    <div class="alert alert-success">Vos modifications ont été enregistrées.</div>
    {% endif %}
    <p>Vous évaluez le candidat dans le cadre de la session <b>{{ session }}</b></p>
    <br>
    <form action="" method="POST">
        {% csrf_token %}
        {% include 'written_exams/form-stub.html' with form=form %}
        <button class="btn btn-success btn-block">Enregistrer</button>
    </form>
</div>
{% endblock %}

valentin/interviews/templates/interviews/contestant-slot-select.html
{% extends 'semifinals/base.html' %}
{% load static %}

{% block base_extra_head %}
<title>Choix de l'entretien</title>
<link rel="stylesheet" href="{% static 'interviews/itw.css' %}">
{% endblock %}

{% block content %}
<div class="container">
    <small class="return-button"><a href="{% url 'interviews:list' %}">&lt;&nbsp; Retour à la liste des sessions</a></small>
    <h1 class="trb">Choix de votre date d'entretien</h1>
    {% if form.errors %}
    <div class="alert alert-danger"><i class="las la-exclamation-circle"></i>&nbsp; L'enregistrement a échoué. Le créneau sélectionné n'est peut être plus disponible. Vous pouvez rééssayer. Si le problème persiste, contactez Prologin</div>
    {% endif %}
    <p>Session : <b>{{ session }} <small>({{ session.id }})</small></b></p>
    <br>

    <h3>Informations aux candidats</h3>
    <p>{{ session.description | linebreaks | urlize }}</p>
    <br><br>

    <h3>Choisissez la date et l'heure de votre entretien</h3>
    <p>Sélectionnez la date d'entretien qui vous convient le mieux.</p>
    <p><em>Remarque : votre choix est définitif, si vous désirez le changer après coup contacter Prologin par mail à l'adresse <a href="mailto:info@prologin.org">info@prologin.org</a>.</em></p>

    <form action="" method="POST">
        {% csrf_token %}
        {% for day_date, slots in grouped_slot_choices %}
        <fieldset class="interview_select">
          <legend>{{ day_date|date:'D d N Y' }}</legend>
            {% for slot in slots %}
            {% with val=slot.id %}
            <input type="radio" name="slot_choice" value="{{ val }}" id="id_slot_choice_{{ val }}">
            <label for="id_slot_choice_{{ val }}">
                {{ slot.date_start |date:'H:i' }} à {{ slot.date_end |date:'H:i' }}
            </label>
            {% endwith %}
            {% endfor %}
        </fieldset>
        {% endfor %}
        <button class="btn btn-block btn-success">Valider définitivement mon choix</button>
    </form>
</div>
{% endblock %}

valentin/interviews/templates/interviews/interviewer-dispos-select.html
{% extends 'semifinals/base.html' %}
{% load static %}

{% block base_extra_head %}
<title>Sélection des disponibilités</title>
<link rel="stylesheet" href="{% static 'interviews/itw.css' %}">
{% endblock %}

{% block content %}
<div class="container">
    <small class="return-button"><a href="{% url 'interviews:list' %}">&lt;&nbsp; Retour à la liste des sessions</a></small>
    <h1 class="trb">Sélections des disponibilités</h1>
    <p>Session : <b>{{ session }} <small>({{ session.id }})</small></b></p>
    <br>

    <h3>Message de l'administrateur</h3>
    <p>{{ session.description | linebreaks | urlize }}</p>
    <br><br>

    <h3>Sélectionnez vos disponibilités</h3>
    <p>Cochez les créneaux auxquels vous êtes sûrs de pouvoir participer.</p>
    {% if session.in_phase_1 %}
    <p><em>Remarque : jusqu'à la fin de la phase 1 vous pouvez vous désister des créneaux que vous avez sélectionné en les décochant.</em></p>
    {% elif session.in_phase_2 %}
    <p><em>Remarque : La session est en phase 2, vous pouvez ajouter des nouvelles disponibilités mais vous ne pouvez pas vous désister des créneaux sur lesquels vous vous êtes engagés.</em></p>
    {% endif %}

    <br>
    <form action="" method="POST">
        {% csrf_token %}
        {% for day_date, slots in grouped_slot_choices %}
        <fieldset class="interview_select">
          <legend>{{ day_date|date:'D d N Y' }}</legend>
            {% for slot in slots %}
            {% with val=slot.id selected=form.slot_choices.value %}
            <input type="checkbox" name="slot_choices" value="{{ val }}" id="id_slot_choice_{{ val }}" {% if val in selected %}checked class="pre_checked" {% if session.in_phase_2 %}disabled{% endif %}{% endif %}>
            <label for="id_slot_choice_{{ val }}">
                {{ slot.date_start |date:'H:i' }} à {{ slot.date_end |date:'H:i' }}
            </label>
            {% endwith %}
            {% endfor %}
        </fieldset>
        {% endfor %}
        <button class="btn btn-block btn-success">Enregistrer mes choix</button>
    </form>

    <div>

    </div>
</div>
{% endblock %}

valentin/interviews/templates/interviews/interviews-list.html
{% extends 'semifinals/base.html' %}
{% load static %}

{% block base_extra_head %}
<title>Mes entretiens</title>
<link rel="stylesheet" href="{% static 'interviews/itw.css' %}">
{% endblock %}

{% block content %}
<div class="container">
    <small class="return-button"><a href="{% url 'interviews:list' %}">&lt;&nbsp; Retour à la liste des sessions</a></small>
    <h1 class="trb">Dérouleur Prévisionnel Entretiens</h1>

    <p>Voici la liste de vos entretiens pour la session <b>{{ session }}</b></p>

    {% if object_list %}
    <ul class="slot-list slot-list-spd">
        {% for object in object_list %}
        <li>
            <span class="va-middle">
                <b>{{ object.slot.local_display }}</b>&nbsp;&nbsp; {{ object.contestant_full_name }}&nbsp;&nbsp;
                {% if object.contestant_id in notations %}
                    <i style="font-weight: bolder; color: var(--color-success);" class="las la-check"></i>
                {% else %}
                    <i style="font-weight: bolder; color: var(--color-danger);" class="las la-times"></i>
                {% endif %}
            </span>
            <span><a href="{% url 'interviews:contestant-grading' session.id object.contestant_id %}" class="btn">Notation</a></span>
        </li>
        {% endfor %}
    </ul>
    {% else %}
    <center><p>Vous n'avez pas encore d'entretiens programmés.</p></center>
    {% endif %}
</div>
{% endblock %}

valentin/interviews/templates/interviews/my-interview.html
{% extends 'semifinals/base.html' %}
{% load static %}

{% block base_extra_head %}
<title>Mon entretien</title>
<link rel="stylesheet" href="{% static 'interviews/itw.css' %}">
{% endblock %}

{% block content %}
<div class="container">
    <small class="return-button"><a href="{% url 'interviews:list' %}">&lt;&nbsp; Retour à la liste des sessions</a></small>
    <h1 class="trb">Votre entretien</h1>

    <h3>Informations importantes</h3>
    <p>{{ object.slot.session.description | linebreaks | urlize }}</p>
    <br>

    <h3>Mon entretien</h3>
    <br>
    <article class="interview-box">
        <h4>{{ object.slot.local_display }}</h4>
        <p>Votre entretien se déroulera en ligne.</p>
        <p>Vous passerez votre entretien avec <b>{{ object.interviewer }}</b>, membre Prologin.</p>
        <p>{{ settings.APP_ITW_MEET_UNLOCK_BEFORE }} minute(s) avant le début de votre entretien un bouton apparaîtra avec un lien
            vers la salle de visioconférence.<br>Rendez-vous donc sur cette page, quelques minutes avant votre entretien.
        </p>
        {% if object.can_see_meet_link and not object.interviewer.meet_link is None %}
        <a href="{{ object.interviewer.meet_link }}" target="_blank" class="btn btn-success btn-block">Accéder à la visioconférence</a>
        {% endif %}
    </article>
</div>
{% endblock %}

valentin/interviews/templates/interviews/no-interview.html
{% extends 'semifinals/base.html' %}

{% block base_extra_head %}
<title>Erreur 404 : Pas d'entretien</title>
{% endblock %}

{% block content %}
<div class="container">
    <small class="return-button"><a href="{% url 'interviews:list' %}">&lt;&nbsp; Retour à la liste des sessions</a></small>
    <h1 class="trb">Erreur 404</h1>
    <center><p>Vous n'avez pas sélectionné votre créneau d'entretien avant la date limite. Si vous souhaitez quand même passer
        un entretien, veuillez contacter Prologin par mail (<a href="mailto:info@prologin.org">info@prologin.org</a>) au plus vite.
    </p></center>
</div>
{% endblock %}

valentin/interviews/templates/interviews/profile-edit.html
{% extends 'semifinals/base.html' %}

{% block base_extra_head %}
<title>Profil Organisateur</title>
{% endblock %}

{% block content %}
<div class="container">
    <small class="return-button"><a href="{% url 'semifinals:home' %}">&lt;&nbsp; Retour à l'espace organisateur</a></small>
    <h1 class="trb">Mon Profil Organisateur</h1>
    <form action="" method="POST">
        {% csrf_token %}
        {% include 'written_exams/form-stub.html' with form=form %}
        <button class="btn btn-block">ENREGISTRER</button>
    </form>
</div>
{% endblock %}

valentin/interviews/templates/interviews/sessions-list.html
{% extends 'semifinals/base.html' %}
{% load static %}

{% block base_extra_head %}
<title>Sessions d'entretien</title>
<link rel="stylesheet" href="{% static 'interviews/itw.css' %}">
{% endblock %}

{% block content %}
<div class="container">
    <small class="return-button"><a href="{% url 'semifinals:home' %}">&lt;&nbsp; Retour à l'accueil</a></small>
    <h1 class="trb">Sessions d'entretiens</h1>
    <p>Vous trouverez ci-dessous la liste des sessions d'entretiens auxquelles vous pouvez participer.</p>

    <section id="sessions-list">
        {% for s in object_list %}
        <article href="#" class="session-instance">
            <div class="left">
                <small>{{ s.id }}</small>
                <h3>{{ s.name }} {% if s.status == 1 %}<i class="las la-eye-slash"></i>{% endif %}</h3>
                <div>
                    {% if request.user.is_staff %}
                        {% if s.status == 1 %}
                            <p><b>PHASE 1</b> : Les organisateurs indiquent leurs disponibilités.</p>
                            <p>Les candidats ne voient pas encore la session</p>
                        {% elif s.status == 2 %}
                            <p><b>PHASE 2</b> : Les candidats choisissent leur créneau d'entretien.</p>
                        {% elif s.status == 3 %}
                            <p>La session est verrouillée. Les candidats peuvent accéder à leur convocation.</p>
                            <p>Vous pouvez accéder à la liste de vos entretiens.</p>
                        {% endif %}
                    {% else %}
                        {% if s.status == 2 %}
                            <p>Vous devez choisir une date pour votre entretien oral.</p>
                            <p>Pour cela cliquez sur <b>Mon entretien</b></p>
                        {% elif  s.status == 3 %}
                            <p>Les choix d'entretiens sont terminés.</p>
                            <p>Cliquez sur mon entretien pour plus d'informations.</p>
                        {% endif %}
                    {% endif %}
                </div>
            </div>
            <div class="right">
                {% if request.user.is_staff %}
                    {% if s.status == 1 %}
                        <a href="{% url 'interviews:dispo-select' s.id %}" class="btn btn-block">Indiquer mes disponibilités</a>
                    {% elif s.status == 2 or s.status == 3 %}
                        <a href="{% url 'interviews:interviewer-interviews' s.id %}" class="btn btn-success btn-block">Mes entretiens</a>
                        {% if s.status == 2 %}
                        <a href="{% url 'interviews:dispo-select' s.id %}" class="btn btn-block">Indiquer mes disponibilités</a>
                        {% endif %}
                    {% endif %}
                {% else %}
                    <a href="{% url 'interviews:contestant-portal' s.id %}" class="btn btn-block">Mon Entretien</a>
                {% endif %}
            </div>
        </article>
        {% endfor %}
    </section>
</div>
{% endblock %}